#include <iostream>
#include <string>
#include "IntBinaryTree.h"
using namespace std;


void printMenu(string & response) {
	
	cout << "Test Binary Search Tree" << endl<< endl;
	cout << "(i)nsert\n";
	cout << "(s)each\n";
	cout << "(r)emove\n";
	cout << "i(n)order display\n";
	cout << "(p)reorder display\n";
	cout << "p(o)storder display\n";
	cout << "si(z)e\n";
	cout << "(q)uit\n";
	cout << "\nWhat would you like to do? ";
	cin >> response;

} // end printMenu

int main() {
	IntBinaryTree myTree;
	string command;
	int value;

	while (true) {
		printMenu(command);
		if (command == "z" || command == "Z") {
//			cout << "tree size " << myTree.size() << endl;
		} else if (command == "i" || command == "I") {
			cout << "Enter the value to insert: ";
			cin >> value;
			myTree.insertNode(value);
			myTree.displayInOrder();
		} else if (command == "s" || command == "S") {
			cout << "Enter the value to search for: ";
			cin >> value;

			if (myTree.searchNode(value)) {
				cout << "The search value " << value << " was FOUND!" << endl;
			} else {
				cout << "The search value " << value << " was NOT FOUND!" << endl;
			} // end if
		} else if (command == "r" || command == "R") {
			cout << "Enter the value to remove: ";
			cin >> value;

			myTree.remove(value);
			cout << "The tree after removing the value " << value << " is:" << endl;			
			myTree.displayInOrder();
		} else if (command == "p" || command == "P") {
			cout << "The preorder tree traversal:" << endl;
			myTree.displayPreOrder();
		} else if (command == "o" || command == "O") {
			cout << "The postorder tree traversal:" << endl;
			myTree.displayPostOrder();
		} else if (command == "n" || command == "N") {
			cout << "The inorder tree traversal:" << endl;
			myTree.displayInOrder();
		} else if (command == "q" || command == "Q") {
			break;
		} // end if

		cout << "\n===================================================" << endl;
	} // end while

	
} // end main